﻿Imports System.Text
Imports Microsoft.VisualStudio.TestTools.UnitTesting

<TestClass()>
Public Class Row1

    Private cs As CalcState
    Private c As Calculator

    '  A,  B,  C,  D,  E,  F, 7,  8,  9, 10
    ' 21, 22, 23, 24, 25, 26, 4,  5,  6, 20
    ' 31, 32, 33, 35, 35, 36, 1,  2,  3, 30
    ' 41, 42, 43, 44, 45,     0, 48, 49, 40

    Private Const KeyA As Integer = 10
    Private Const KeyB As Integer = 11
    Private Const KeyC As Integer = 12
    Private Const KeyD As Integer = 13
    Private Const KeyE As Integer = 14
    Private Const KeyF As Integer = 15
    Private Const Key7 As Integer = 7
    Private Const Key8 As Integer = 8
    Private Const Key9 As Integer = 9
    Private Const KeyDiv As Integer = 16
    Private Const KeyGSB As Integer = 33
    Private Const KeyGTO As Integer = 34
    Private Const KeyHEX As Integer = 35
    Private Const KeyDEC As Integer = 36
    Private Const KeyOCT As Integer = 37
    Private Const KeyBIN As Integer = 38
    Private Const Key4 As Integer = 4
    Private Const Key5 As Integer = 5
    Private Const Key6 As Integer = 6
    Private Const KeyMul As Integer = 32
    Private Const KeyRS As Integer = 49
    Private Const KeySST As Integer = 50
    Private Const KeyRol As Integer = 51
    Private Const KeyXY As Integer = 52
    Private Const KeyBSP As Integer = 53
    Private Const KeyEnt As Integer = 54
    Private Const Key1 As Integer = 1
    Private Const Key2 As Integer = 2
    Private Const Key3 As Integer = 3
    Private Const KeyMin As Integer = 48
    Private Const KeyON As Integer = 65
    Private Const KeyFKey As Integer = 66
    Private Const KeyGKey As Integer = 67
    Private Const KeySTO As Integer = 68
    Private Const KeyRCL As Integer = 69
    Private Const Key0 As Integer = 0
    Private Const KeyDp As Integer = 72
    Private Const KeyCHS As Integer = 73
    Private Const KeyAdd As Integer = 64

    Public Sub New()
        MyBase.New
        cs = New CalcState
        c = New Calculator(cs)
    End Sub

    ' Test all of the yellow-shifted function on the first row.  Uses both positive And
    ' negative numbers And all 3 arithmetic modes

    <TestMethod()>
    Public Sub row1Yellow()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)

        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyA)        ' SL
        Assert.AreEqual("6 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyB)        ' SR
        Assert.AreEqual("1 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyC)        ' RL
        Assert.AreEqual("6 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyD)        ' RR
        Assert.AreEqual("-32766 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyE)        ' RLn
        Assert.AreEqual("12 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyF)        ' RRn
        Assert.AreEqual("-16383 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(7)        ' MASKL
        Assert.AreEqual("-8191 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(8)        ' MASKR
        Assert.AreEqual("7 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(9)        ' RMD
        Assert.AreEqual("1 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDiv)        ' XOR
        Assert.AreEqual("1 d", dp.DisplayText)

        ' Round 2... using negative numbers (And 1's complement)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyA)        ' SL
        Assert.AreEqual("-7 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyB)        ' SR
        Assert.AreEqual("32766 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyC)        ' RL
        Assert.AreEqual("-6 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyD)        ' RR
        Assert.AreEqual("32766 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyE)        ' RLn
        Assert.AreEqual("-12 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyF)        ' RRn
        Assert.AreEqual("16383 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(7)        ' MASKL
        Assert.AreEqual("-8191 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(8)        ' MASKR
        Assert.AreEqual("7 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(9)        ' RMD
        Assert.AreEqual("-1 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyCHS)        ' switched which one is neg
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(9)        ' RMD
        Assert.AreEqual("1 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDiv)        ' XOR
        Assert.AreEqual("-1 d", dp.DisplayText)

        ' Round 3 ... using positive numbers and 2's complement

        ' 2's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(2)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyA)        ' SL
        Assert.AreEqual("6 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyB)        ' SR
        Assert.AreEqual("1 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyC)        ' RL
        Assert.AreEqual("6 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyD)        ' RR
        Assert.AreEqual("-32767 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyE)        ' RLn
        Assert.AreEqual("12 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyF)        ' RRn
        Assert.AreEqual("-16384 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(7)        ' MASKL
        Assert.AreEqual("-8192 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(8)        ' MASKR
        Assert.AreEqual("7 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(9)        ' RMD
        Assert.AreEqual("1 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDiv)        ' XOR
        Assert.AreEqual("1 d", dp.DisplayText)

        ' Round 4... using negative numbers (And 2's complement)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyA)        ' SL
        Assert.AreEqual("-6 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyB)        ' SR
        Assert.AreEqual("32766 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyC)        ' RL
        Assert.AreEqual("-5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyD)        ' RR
        Assert.AreEqual("-2 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyE)        ' RLn
        Assert.AreEqual("-9 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyF)        ' RRn
        Assert.AreEqual("32767 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(7)        ' MASKL
        Assert.AreEqual("-8192 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(8)        ' MASKR
        Assert.AreEqual("7 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(9)        ' RMD
        Assert.AreEqual("-1 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyCHS)        ' switched which one is neg
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(9)        ' RMD
        Assert.AreEqual("1 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDiv)        ' XOR
        Assert.AreEqual("-1 d", dp.DisplayText)

        ' Round 5... unsigned (no need to test for negative numbers)

        ' unsigned mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(3)
        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyA)        ' SL
        Assert.AreEqual("6 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyB)        ' SR
        Assert.AreEqual(dp.DisplayText, "1 d")
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyC)        ' RL
        Assert.AreEqual("6 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyD)        ' RR
        Assert.AreEqual("32769 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyE)        ' RLn
        Assert.AreEqual("12 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyF)        ' RRn
        Assert.AreEqual("49152 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(7)        ' MASKL
        Assert.AreEqual("57344 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(8)        ' MASKR
        Assert.AreEqual("7 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(9)        ' RMD
        Assert.AreEqual("1 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDiv)        ' XOR
        Assert.AreEqual("1 d", dp.DisplayText)
    End Sub

    <TestMethod()>
    Public Sub row1Blue()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)

        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)

        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        ' Round 1... using positive numbers and 1's complement

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyA)        ' LF
        Assert.AreEqual("14 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("-16383 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyB)        ' ASR
        Assert.AreEqual("1 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("6 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("7 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("1 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("-32766 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("12 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("14 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("-32767 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("-16383 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(7)        ' #B
        Assert.AreEqual("2 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(8)        ' ABS
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDiv)        ' DBLd
        Assert.AreEqual("8192 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        ' Round 2... using negative numbers and 1's complement

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyA)        ' LF
        Assert.AreEqual("0 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("-3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyB)        ' ASR
        Assert.AreEqual("-1 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("-7 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("-6 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("32766 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("-1 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("-14 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("-12 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("16383 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("32767 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(7)        ' #B
        Assert.AreEqual("14 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(8)        ' ABS
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("12 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyCHS)        ' reversed
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyCHS)        ' reversed
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("-12 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDiv)        ' DBLd
        Assert.AreEqual("12287 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDiv)        ' DBLd
        Assert.AreEqual("-12287 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        ' Round 3... using positive numbers and 2's complement

        ' 2's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(2)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyA)        ' LF
        Assert.AreEqual("14 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("-16384 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyB)        ' ASR
        Assert.AreEqual("1 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("6 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("7 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("1 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("-32767 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("12 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("14 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("-32768 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("-16384 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(7)        ' #B
        Assert.AreEqual("2 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(8)        ' ABS
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDiv)        ' DBLd
        Assert.AreEqual("8192 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        ' Round 4... using negative numbers and 2's complement

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyA)        ' LF
        Assert.AreEqual("0 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("-3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyB)        ' ASR
        Assert.AreEqual("-2 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("-6 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("-5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("32766 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("-2 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("-11 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("-9 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("-16385 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("-1 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(7)        ' #B
        Assert.AreEqual("15 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(8)        ' ABS
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("13 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyCHS)        ' reversed
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyCHS)        ' reversed
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("-13 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDiv)        ' DBLd
        Assert.AreEqual("12287 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDiv)        ' DBLd
        Assert.AreEqual("-8191 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        ' Round 5... unsigned (no need to test for negative numbers)

        ' unsigned mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(3)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyA)        ' LF
        Assert.AreEqual("14 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("49152 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyB)        ' ASR
        Assert.AreEqual("1 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("6 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyC)        ' RLC
        Assert.AreEqual("7 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("1 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyD)        ' RRC
        Assert.AreEqual("32769 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("12 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyE)        ' RLCn
        Assert.AreEqual("14 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Carry_Annunciator)

        clearCarry()
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("32768 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        setCarry()        ' again, but with carry bit set
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyF)        ' RRCn
        Assert.AreEqual("49152 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(7)        ' #B
        Assert.AreEqual("2 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(8)        ' ABS
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(9)        ' DBLR
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDiv)        ' DBLd
        Assert.AreEqual("8192 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)
    End Sub

    <TestMethod()>
    Public Sub row1White()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)

        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)

        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        ' Round 1... using positive numbers and 1's complement

        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        dp = c.ProcessKey(KeyDiv)    ' Div
        Assert.AreEqual("5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        ' Round 2... using negative numbers and 1's complement

        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        dp = c.ProcessKey(KeyDiv)    ' Div
        Assert.AreEqual("-5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        dp = c.ProcessKey(KeyDiv)    ' Div
        Assert.AreEqual("-5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        ' Round 3... using positive numbers and 2's complement

        ' 2's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(2)

        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        dp = c.ProcessKey(KeyDiv)    ' Div
        Assert.AreEqual("5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        ' Round 4... using negative numbers and 2's complement

        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        dp = c.ProcessKey(KeyDiv)    ' Div
        Assert.AreEqual("-5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        dp = c.ProcessKey(KeyDiv)    ' Div
        Assert.AreEqual("-5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        ' Round 5... positive numbers and unsigned

        ' unsigned mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(3)

        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        dp = c.ProcessKey(KeyDiv)    ' Div
        Assert.AreEqual("5 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)
    End Sub

    Private Sub clearCarry()
        c.ProcessKey(KeyGKey)
        c.ProcessKey(5)
        c.ProcessKey(4)
    End Sub

    Private Sub setCarry()
        c.ProcessKey(KeyGKey)
        c.ProcessKey(4)
        c.ProcessKey(4)
    End Sub
End Class