﻿Imports System.Text
Imports Microsoft.VisualStudio.TestTools.UnitTesting

<TestClass()>
Public Class Row3

    Private cs As CalcState
    Private c As Calculator
    Private p As Prgm

    '  A,  B,  C,  D,  E,  F, 7,  8,  9, 10
    ' 21, 22, 23, 24, 25, 26, 4,  5,  6, 20
    ' 31, 32, 33, 35, 35, 36, 1,  2,  3, 30
    ' 41, 42, 43, 44, 45,     0, 48, 49, 40

    Private Const KeyA As Integer = 10
    Private Const KeyB As Integer = 11
    Private Const KeyC As Integer = 12
    Private Const KeyD As Integer = 13
    Private Const KeyE As Integer = 14
    Private Const KeyF As Integer = 15
    Private Const Key7 As Integer = 7
    Private Const Key8 As Integer = 8
    Private Const Key9 As Integer = 9
    Private Const KeyDiv As Integer = 16
    Private Const KeyGSB As Integer = 33
    Private Const KeyGTO As Integer = 34
    Private Const KeyHEX As Integer = 35
    Private Const KeyDEC As Integer = 36
    Private Const KeyOCT As Integer = 37
    Private Const KeyBIN As Integer = 38
    Private Const Key4 As Integer = 4
    Private Const Key5 As Integer = 5
    Private Const Key6 As Integer = 6
    Private Const KeyMul As Integer = 32
    Private Const KeyRS As Integer = 49
    Private Const KeySST As Integer = 50
    Private Const KeyRol As Integer = 51
    Private Const KeyXY As Integer = 52
    Private Const KeyBSP As Integer = 53
    Private Const KeyEnt As Integer = 54
    Private Const Key1 As Integer = 1
    Private Const Key2 As Integer = 2
    Private Const Key3 As Integer = 3
    Private Const KeyMin As Integer = 48
    Private Const KeyON As Integer = 65
    Private Const KeyFKey As Integer = 66
    Private Const KeyGKey As Integer = 67
    Private Const KeySTO As Integer = 68
    Private Const KeyRCL As Integer = 69
    Private Const Key0 As Integer = 0
    Private Const KeyDp As Integer = 72
    Private Const KeyCHS As Integer = 73
    Private Const KeyAdd As Integer = 64

    Public Sub New()
        MyBase.New
        cs = New CalcState
        c = New Calculator(cs)
        p = New Prgm(cs, c)
    End Sub

    <TestMethod()>
    Public Sub row3Yellow()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        ' Note: (i) and I have already been covered by the programming test

        cs.PrgmPosition = 5
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyRol)    ' Clear PRGM
        Assert.AreEqual(0, cs.PrgmPosition)

        p.simpleProgram()
        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyRS)
        ' enter program mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyRol)    ' Clear PRGM
        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyRS)
        ' exit
        Assert.AreEqual(0, cs.PrgmMemory.Count)

        c.ProcessKey(5)
        c.ProcessKey(KeySTO)
        c.ProcessKey(5)
        ' put a 5 in Reg 5
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyXY)

        Dim i As Integer
        For i = 0 To 31         ' Clear all registers
            c.ProcessKey(KeyRCL)
            dp = c.ProcessKey(i)
            Assert.AreEqual("0 d", dp.DisplayText)
        Next

        c.ProcessKey(5)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)   ' clear the STO "prefix" key
        c.ProcessKey(KeyBSP)
        dp = c.ProcessKey(3)    ' Clear Prefix
        Assert.AreEqual("53 d", dp.DisplayText)

        ' Change word size

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 64 bit word size
        c.ProcessKey(6)
        c.ProcessKey(4)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-64-1000", dp.AlternateText)

        c.ProcessKey(2)      ' 2 billion
        i = 0
        For i = 0 To 8
            c.ProcessKey(0)
        Next

        c.ProcessKey(KeyEnt)
        c.ProcessKey(4)
        c.ProcessKey(0)
        c.ProcessKey(0)        ' 4 hundred
        dp = c.ProcessKey(KeyMul)   ' Mul
        Assert.AreEqual("800000000000 d", dp.DisplayText)

        dp = c.ProcessKey(KeyBIN)   'Win 0
        Assert.AreEqual("01000011 10110111 01000000 00000000 .b", dp.DisplayText)

        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyEnt)
        dp = c.ProcessKey(1)    ' Win 1
        Assert.AreEqual("00000000 00000000 00000000 10111010 b.", dp.DisplayText)

        ' I think 1's, 2's, and unsigned have already been tested enough

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-16-1000", dp.AlternateText)

        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyMin)
        Assert.AreEqual("-3 d", dp.DisplayText)
    End Sub

    <TestMethod()>
    Public Sub row3Blue()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        ' no need to test P/R here.. is already covered by SimpleProgram

        p.simpleProgram()
        cs.PrgmPosition = 5
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeySST)   ' BST
        Assert.AreEqual(4, cs.PrgmPosition)

        c.ProcessKey(1)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(2)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(4)        ' fill the stack
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyRol)   ' Roll Up
        Assert.AreEqual("1 d", dp.DisplayText)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyRol)   ' Roll Up
        Assert.AreEqual("2 d", dp.DisplayText)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyRol)   ' Roll Up
        Assert.AreEqual("3 d", dp.DisplayText)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyRol)   ' (Fruit?) Roll Up
        Assert.AreEqual("4 d", dp.DisplayText)

        ' difficult to test PSE in a Unit Test...

        c.ProcessKey(1)
        c.ProcessKey(2)
        c.ProcessKey(3)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyBSP)    ' CLx
        Assert.AreEqual("0 d", dp.DisplayText)

        ' this part needs the test above...
        dp = c.ProcessKey(KeyRol)   ' Roll Down
        Assert.AreEqual("4 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)   ' Roll Down
        Assert.AreEqual("3 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)   ' Roll Down
        Assert.AreEqual("2 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)   ' Roll Down
        Assert.AreEqual("0 d", dp.DisplayText)

        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key1) ' x<=y
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey) ' x<=y
        dp = c.ProcessKey(Key1)
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(6)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key1) ' x<=y
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key1) ' x<=y
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key1) ' x<=y
        Assert.AreEqual(6, cs.PrgmPosition)

        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key2) ' x<0
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(0)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key2) ' x<0
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(1)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key2) ' x<0
        Assert.AreEqual(5, cs.PrgmPosition)

        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key3) ' x>y
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key3) ' x>y
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(6)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key3) ' x>y
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key3) ' x>y
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key3) ' x>y
        Assert.AreEqual(5, cs.PrgmPosition)

        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyMin)   ' x>0
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(0)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyMin)   ' x>0
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(1)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyMin)   ' x>0
        Assert.AreEqual(6, cs.PrgmPosition)
    End Sub

    <TestMethod()>
    Public Sub row3White()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        p.simpleProgram()
        cs.PrgmPosition = 5
        dp = c.ProcessKey(KeySST)   ' SST
        Assert.AreEqual(6, cs.PrgmPosition)

        ' Rol has already been covered
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        dp = c.ProcessKey(KeyXY)    ' x:y
        Assert.AreEqual("5 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("6 d", dp.DisplayText)

        c.ProcessKey(1)
        c.ProcessKey(2)
        c.ProcessKey(3)
        dp = c.ProcessKey(KeyBSP)   ' BSP
        Assert.AreEqual("12 d", dp.DisplayText)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        dp = c.ProcessKey(KeyBSP)   ' no harm doing it twice
        Assert.AreEqual("0 d", dp.DisplayText)
        dp = c.ProcessKey(KeyBSP)
        Assert.AreEqual("0 d", dp.DisplayText)

        ' I think this is already covered...
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        dp = c.ProcessKey(KeyMin)   ' min
        Assert.AreEqual("-1 d", dp.DisplayText)
    End Sub
End Class